//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include "hpgraphics.h"
#include "hpgpriv.h"

void hpg_clip(hpg_t *g, int x1, int y1, int x2, int y2)
{
    hpg_init();
    if(g==NULL) g=HPG_STDSCREEN;

    g->clipx1 = max(x1, g->clipx1);
    g->clipy1 = max(y1, g->clipy1);
    g->clipx2 = min(x2, g->clipx2);
    g->clipy2 = min(y2, g->clipy2);
}
