//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


#include <keyb.h>


// TURNED INTO A LOW-LEVEL FUNCTION TO BE USED BY THE
// EXCEPTION SUBSYSTEM ONLY


const unsigned short const __keyb_shiftconvert[8]={
0,
SHIFT_ALPHA|SHIFT_ALPHAHOLD,
SHIFT_LS|SHIFT_LSHOLD,
SHIFT_ALPHA|SHIFT_ALPHAHOLD|SHIFT_LS|SHIFT_LSHOLD,
SHIFT_RS|SHIFT_RSHOLD,
SHIFT_ALPHA|SHIFT_ALPHAHOLD|SHIFT_RS|SHIFT_RSHOLD,
SHIFT_LS|SHIFT_LSHOLD|SHIFT_RS|SHIFT_RSHOLD,
SHIFT_LS|SHIFT_LSHOLD|SHIFT_ALPHA|SHIFT_ALPHAHOLD|SHIFT_RS|SHIFT_RSHOLD
};

extern keymatrix __keyb_getmatrix();
extern keymatrix __keyb_getmatrixEX();



int __keyb_getkey(int wait)
{
// by Claudio
	
    keymatrix m;
    m=__keyb_getmatrixEX();

    if(wait) {
        // wait for a non-shift key to be pressed
        while( (m&0x8fffffffffffffffLL )==0LL ) m=__keyb_getmatrixEX();
    }

    int kcode,shft=(m>>60)&0x7;
    unsigned char *mbytes=(unsigned char *)&m;
    int k;
    for(k=0,kcode=0;k<8;++mbytes,++k,kcode+=8)
    {
        if(*mbytes!=0) {
            k=*mbytes;
            while( !(k&1) ) {
                k>>=1;
                ++kcode;
                }
        break;
        }
    }


    if(wait) {
        while( (m&0x8fffffffffffffffLL )!=0 ) m=__keyb_getmatrixEX();
    if(kcode>=60) kcode=63;
    }
    
    if(kcode<60) return kcode | __keyb_shiftconvert[shft];
    if(kcode<64) return kcode;
    return 0;

}


void __keyb_waitrelease()
{
	keymatrix m=1;
	while(m!=0LL) { m=__keyb_getmatrixEX(); }
}
