//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

#include <stdlib.h>
#include <master_globals.h>

// Added by iblank 2004-10-23

/*
RNDFUNC __rand_hook = mwc ; 

extern int __srand_initialized;
 
unsigned int
rand_bits(int bits)
{
    return (*__rand_hook)(bits);
}

unsigned int
rand()
{
    // Conforms to UNIX manpage, ANSI ?
    // <ibl ; 2005-03-29>
    if (! __srand_initialized )
        srand(1);
    
    return rand_bits(32);
}

*/

 /*
  * Basic simplification of the RNG framework for the ROMLIB.
  * rand() is now 'hardwired' to mwc() and no longer hooked.
  */

// ROMLIB CHECKED
// < ibl ; 2006-04-03 >

unsigned int
rand_bits(int n)
{
    if (__mg->__mwc_w == 0LL)
    // Conforms to UNIX manpage, ANSI ?    
        srand(1);
    
    return mwc(n);
}

int
rand()
{
    return (int) rand_bits(31);
}

