//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_copyobject.c 511 2007-11-13 01:42:01Z claudio $

#include <hpgcc3.h>
#include <master_globals.h>


SAT_OBJECT sat3_copyobject(SAT_OBJECT dest,SAT_OBJECT source)
{
if(!source) return 0;
if(sat3_isptr(source)) source=sat3_peek(source,5);
int size=(int)(sat3_skipob(source)-source);

dest=sat3_alloc(dest,size);
if(!dest) return 0; // FAIL IF NOT ENOUGH SPACE

sat3_memmove(dest,source,size);

return dest;
}
