//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

#include <conio.h>
#include <master_globals.h>

const _CONSOLE const __console[3]={
		{	// CONSOLE 0 = /dev/null
				&dummy_putchar,
				&dummy_puts,
				&dummy_puts_nonl,
				&dummy_getchar,
				&dummy_gets,
				&dummy_clreol,
				&dummy_clear_screen,
				&dummy_gotoxy,
				&dummy_wherexy
		},
		{	// CONSOLE 1 = OLD STYLE CONSOLE
				&putchar_orig,
				&puts_orig,
				&puts_nonl_orig,
				&getchar_orig,
				&gets_orig,
				&clreol_orig,
				&clear_screen_orig,
				&gotoxy_orig,
				&wherexy_orig
		},
		{	// CONSOLE 2 = NEW GREYSCALE CONSOLE
				&putcharConsole,
				&putsConsole,
				&puts_nonlConsole,
				&getcharConsole,
				&getsConsole,
				&clreolConsole,
				&clearConsole,
				&gotoxyConsole,
				&wherexyConsole
		}
};


void __console_init(int idx)
{
	if((idx<1)||(idx>2)) idx=0;
	__mg->__console_type=idx;

	if(idx==1) {
		__mg->__console_vars=malloc(sizeof(_CONSOLE_GLOBALS));
		if(__mg->__console_vars==NULL) {
			// FAILED TO ALLOCATE CONSOLE VARIABLES, SIMPLY FALL BACK TO NULL CONSOLE
			__mg->__console_type=0;
			return;
		}
	__mg->__console_vars->__scr_w = 33;
	__mg->__console_vars->__ch_w=4;
	__mg->__console_vars->__ch_h=6;
	__mg->__console_vars->__decimal_separator=".";
	__mg->__console_vars->__decimal_digits=6;
	__mg->__console_vars->__auto_cr=1;

	unsigned int volatile * LCDSADDR1 = (unsigned volatile int*) 0x7300014;
	__mg->__console_vars->__display_buf = (*LCDSADDR1 &0xffff)*2 + 0x7f00000;
	__mg->__console_vars->__scr_h=(lcd_getheight()==64)? 10:13;
	}
}
