//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: launcher.h 396 2007-03-05 03:50:33Z ingo $


// helper functions: standard versions use globals, so they won't work here


unsigned int __launch_s2a(unsigned int sat_addr,SAT_CPU *cpu);

unsigned __launch_peek(int sataddr,int nibbles,SAT_CPU *cpu);
unsigned __launch_peekarm(int armaddr,int nibbles,SAT_CPU *cpu);

void __launch_poke(int sataddr,unsigned val,int nibbles,SAT_CPU *cpu);
void __launch_memmove(int satdest,int satsrc,int nibbles,SAT_CPU *cpu);

int *launch_alloc_ram(unsigned int ram_req, int *kos_mem,SAT_CPU *cpu);
int launch_align_code(int *mmu_table,int code_addr,int codesize, SAT_CPU *cpu);
int launch_rcl_romp(int rompaddr,SAT_CPU *cpu);

void __launch_flush_cache();

void __launch_loader(unsigned int *data_start, unsigned int data_size,unsigned int bss_size,unsigned int saturn);
void __launch_initglobals(int sat_cpu,int hbase,int nentries);

void launch_start();
